.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include dummy_control.inc

DummyProc  PROTO :DWORD,:DWORD,:DWORD,:DWORD


HM STRUCT
	hWnd dd ?
	cnt  dd ?
HM ENDS

WndProcThunk STRUCT BYTE
	m_mov     dd ?
	m_this    dd ?
	m_jmp     db ?
	m_relproc dd ?
WndProcThunk ENDS

.data
	classname  db "dummy_control",0
	im_bad     db "I'M BAD!"
	im_rel_bad db "I'M REALLY REALLY BAD!"
	
.data?
	glob_heap dd ?
	hInstance dd ?
	test_con1 dd ?
	test_con2 dd ?

.const
	TESTM_INCCOUNT equ WM_USER+1
	
.code

start:

	invoke GetModuleHandle, 0
	mov	   hInstance, eax
	invoke GetProcessHeap
	mov    glob_heap, eax
    invoke InitCommonControls
    call   CreateClass
	invoke DialogBoxParam, hInstance, 1000, 0, ADDR DlgProc, 0
	invoke ExitProcess, 0


CreateClass PROC
	LOCAL  wc:WNDCLASSEX

	mov	   wc.cbSize,      SIZEOF WNDCLASSEX
	mov    wc.style,       CS_GLOBALCLASS
	mov	   wc.lpfnWndProc, OFFSET DummyProc
	mov    wc.cbClsExtra,  0
	mov	   wc.cbWndExtra,  0
	push   hInstance
	pop	   wc.hInstance
	mov	   wc.hbrBackground, 0
	mov	   wc.lpszMenuName,  0
	mov	   wc.lpszClassName, OFFSET classname
	mov	   eax, 0
	mov	   wc.hIcon,   eax
	mov	   wc.hIconSm, eax
	invoke LoadCursor, 0, IDC_ARROW
	mov	   wc.hCursor, eax
	invoke RegisterClassEx, ADDR wc
	ret

CreateClass ENDP

DummyProc proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	
	; allocate two structures for saving unique properties
	mov    ecx, sizeof HM            ; control properties
	add    ecx, sizeof WndProcThunk  ; thunk code
	invoke HeapAlloc, glob_heap, 0, ecx
	mov    ecx, hWin
	mov    HM.hWnd[eax], ecx
	mov    HM.cnt[eax], 0
	mov    esi, eax
	add    esi, sizeof HM
		
	; figure out relative address
	mov    ecx, OFFSET TestConProc
	sub    ecx, eax
	sub    ecx, sizeof WndProcThunk
	sub    ecx, sizeof HM
	mov	   DWORD PTR [esi+0], 042444C7h ; sorta trick
	mov	   DWORD PTR [esi+4], eax       ; sorta eax -> this
	mov	   BYTE  PTR [esi+8], 0E9h      ; sorta jmp
	mov	   DWORD PTR [esi+9], ecx       ; sorta relative proc addr
		
	invoke SetWindowLong, hWin, GWL_WNDPROC, esi
	
	; return pProc(hWnd, uMsg, wParam, lParam);
	push   lParam
	push   wParam
	push   uMsg
	push   hWin
	call   esi
	ret
		
DummyProc endp

TestConProc proc uses ebx hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	LOCAL ps:PAINTSTRUCT

	mov    ebx, hWin
	mov    eax, uMsg
	.if eax==TESTM_INCCOUNT
		mov    eax, HM.cnt[ebx]
		inc    eax
		mov    HM.cnt[ebx], eax
		invoke InvalidateRect, HM.hWnd[ebx], 0, 1
		
	.elseif eax==WM_PAINT
		invoke BeginPaint, HM.hWnd[ebx], ADDR ps
		invoke GetParent,  HM.hWnd[ebx]
		invoke SendMessage, eax, WM_GETFONT, 0, 0
		invoke SelectObject, ps.hdc, eax
		invoke SetBkColor,   ps.hdc, 0ffffffh
		invoke ExtTextOut,   ps.hdc, 0, 0, ETO_OPAQUE, ADDR ps.rcPaint, 0, 0, 0
		invoke SetTextColor, ps.hdc, 0
		mov    esi, HM.cnt[ebx]
		test   esi, esi
		jz     @no_bad
		@@:
		dec    esi
		mov    ecx, esi
		shl    ecx, 4
		invoke ExtTextOut, ps.hdc, 0, ecx, ETO_OPAQUE, 0, ADDR im_bad, 8, 0
		test   esi, esi
		jnz    @B
		@no_bad:
		mov    ecx, HM.cnt[ebx]
		shl    ecx, 4
		invoke ExtTextOut, ps.hdc, 0, ecx, ETO_OPAQUE, 0, ADDR im_rel_bad, 22, 0
		invoke EndPaint,   HM.hWnd[ebx], ADDR ps
		
	.elseif eax==WM_NCDESTROY
		invoke HeapFree, glob_heap, 0, ebx
		
	.else
		invoke DefWindowProc, HM.hWnd[ebx], uMsg, wParam, lParam
		ret
	.endif
	
	xor eax, eax
	ret

TestConProc endp

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		invoke CreateWindowEx, WS_EX_STATICEDGE, ADDR classname, 0, WS_CHILD+WS_VISIBLE,  10, 40, 180, 200, hWin, 0, hInstance, 0
		mov    test_con1, eax
		invoke CreateWindowEx, WS_EX_STATICEDGE, ADDR classname, 0, WS_CHILD+WS_VISIBLE, 200, 40, 180, 200, hWin, 0, hInstance, 0
		mov    test_con2, eax
		
	.elseif eax==WM_COMMAND
		mov    eax, wParam
		.if eax == 1001
			invoke SendMessage, test_con1, TESTM_INCCOUNT, 0, 0
		.elseif eax == 1002
			invoke SendMessage, test_con2, TESTM_INCCOUNT, 0, 0
		.endif
		
	.elseif eax==WM_CLOSE
		invoke EndDialog, hWin, 0
		
	.else
		mov		eax, 0
		ret
	.endif
	mov		eax, 1
	ret

DlgProc endp

end start
